(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("angular-base64"), require("ngstorage"), require("angular"), require("osm-auth"));
	else if(typeof define === 'function' && define.amd)
		define(["angular-base64", "ngstorage", "angular", "osm-auth"], factory);
	else if(typeof exports === 'object')
		exports["name"] = factory(require("angular-base64"), require("ngstorage"), require("angular"), require("osm-auth"));
	else
		root["angular-osm"] = root["angular-osm"] || {}, root["angular-osm"]["name"] = factory(root["angular-base64"], root["ngstorage"], root["angular"], root["osm-auth"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_2__, __WEBPACK_EXTERNAL_MODULE_6__, __WEBPACK_EXTERNAL_MODULE_10__, __WEBPACK_EXTERNAL_MODULE_13__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _angular = __webpack_require__(10);

	var _angular2 = _interopRequireDefault(_angular);

	var _oauth = __webpack_require__(11);

	var _oauth2 = _interopRequireDefault(_oauth);

	var _api = __webpack_require__(1);

	var _api2 = _interopRequireDefault(_api);

	var _overpass = __webpack_require__(14);

	var _overpass2 = _interopRequireDefault(_overpass);

	var _taginfo = __webpack_require__(16);

	var _taginfo2 = _interopRequireDefault(_taginfo);

	var _settings = __webpack_require__(4);

	var _settings2 = _interopRequireDefault(_settings);

	var _nominatim = __webpack_require__(18);

	var _nominatim2 = _interopRequireDefault(_nominatim);

	var _togeojson = __webpack_require__(20);

	var _togeojson2 = _interopRequireDefault(_togeojson);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	_angular2.default.module('osm', [_settings2.default.name, _api2.default.name, _overpass2.default.name, _taginfo2.default.name, _oauth2.default.name, _nominatim2.default.name, _togeojson2.default.name]);

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _angularBase = __webpack_require__(2);

	var _angularBase2 = _interopRequireDefault(_angularBase);

	var _api = __webpack_require__(3);

	var _api2 = _interopRequireDefault(_api);

	var _settings = __webpack_require__(4);

	var _settings2 = _interopRequireDefault(_settings);

	var _utils = __webpack_require__(7);

	var _utils2 = _interopRequireDefault(_utils);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	//The base64 module is only available as IIFE

	var osmAPIModule = angular.module('osm.api', [_settings2.default.name, _utils2.default.name, 'base64']).service('osmAPI', _api2.default).provider('osmAPI', function osmAPIProvider() {
	    this.options = {
	        url: 'http://api.openstreetmap.org/api'
	    };
	    this.$get = function osmAPIFactory($base64, $http, $q, osmSettingsService, osmUtilsService) {
	        return new _api2.default($base64, $http, $q, osmSettingsService, osmUtilsService, this.options);
	    };
	    this.$get.$inject = ['$base64', '$http', '$q', 'osmSettingsService', 'osmUtilsService'];
	});

	exports.default = osmAPIModule;

/***/ },
/* 2 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_2__;

/***/ },
/* 3 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

	/**
	 * @ngdoc service
	 * @name osm.oauth.osmAuthService
	 * @description The main idea is use geojson object where it is possible
	 * for the rest of the API (changeset, ...) it's XML2JS that is used so always expect objects.
	 * @param  {any} $base64
	 * @param  {any} $http
	 * @param  {any} $q
	 * @param  {any} osmSettingsService
	 */
	function osmAPI($base64, $http, $q, osmSettingsService, osmUtilsService, options) {

	    this.url = options.url;
	    // ------------------ CREDENTIALS -----------------

	    /**
	     * @ngdoc method
	     * @name validateCredentials
	     * @description if you don't use oauth, you can manage
	     * credentials here using base64 headers
	     * @methodOf osm.api.osmAPI
	     * @returns {Promise} true/false
	    */
	    this.validateCredentials = function () {
	        var deferred = $q.defer();
	        this.getUserDetails().then(function (data) {
	            if (data.osm.user) {
	                osmSettingsService.setUserID(data.osm.user._id);
	            }
	            deferred.resolve(data.osm.user !== undefined);
	        }, function (error) {
	            deferred.reject(error);
	        });
	        return deferred.promise;
	    };
	    /**
	     * @ngdoc method
	     * @name setCredentials
	     * @description if you don't use oauth, you can save
	     * credentials here using base64 localstorage (completly unsecure)
	     * @methodOf osm.api.osmAPI
	     * @returns {string} crendentials
	    */
	    this.setCredentials = function (username, password) {
	        osmSettingsService.setUserName(username);
	        var credentials = $base64.encode(username + ':' + password);
	        osmSettingsService.setCredentials(credentials);
	        return credentials;
	    };
	    /**
	     * @ngdoc method
	     * @name getCredentials
	     * @description if you don't use oauth, you can manage
	     * credentials here using base64 headers
	     * @methodOf osm.api.osmAPI
	     * @returns {string} crendentials from the last set
	    */
	    this.getCredentials = function () {
	        return osmSettingsService.getCredentials();
	    };
	    /**
	     * @ngdoc method
	     * @name getAuthorization
	     * @description compute authorization header from credentials
	     * @methodOf osm.api.osmAPI
	     * @returns {string} HTTP Header 'Basic CREDENTIAL AS BASE64'
	    */
	    this.getAuthorization = function () {
	        return 'Basic ' + osmSettingsService.getCredentials();
	    };
	    /**
	     * @ngdoc method
	     * @name clearCredentials
	     * @description remove credentials from the localstorage
	     * @methodOf osm.api.osmAPI
	     * @returns {string} HTTP Header 'Basic CREDENTIAL AS BASE64'
	    */
	    this.clearCredentials = function () {
	        osmSettingsService.setCredentials('');
	    };

	    /**
	     * @ngdoc method
	     * @name setOauth
	     * @description use oauth object to call API
	     * @methodOf osm.api.osmAPI
	    */
	    this.setOauth = function setOauth(oauth) {
	        this._oauth = oauth;
	    };

	    /**
	     * @ngdoc method
	     * @name setOauth
	     * @description use oauth object to call API
	     * @methodOf osm.api.osmAPI
	     * @return {Object} oauth
	    */
	    this.getOauth = function getOauth() {
	        return this._oauth;
	    };

	    // ------------------ INTERNAL CALL SERVER (API) -----------------

	    function isElement(obj) {
	        try {
	            //Using W3 DOM2 (works for FF, Opera and Chrom)
	            return obj instanceof HTMLElement;
	        } catch (e) {
	            //Browsers not supporting W3 DOM2 don't have HTMLElement and
	            //an exception is thrown and we end up here. Testing some
	            //properties that all elements have. (works on IE7)
	            return (typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === "object" && obj.nodeType === 1 && _typeof(obj.style) === "object" && _typeof(obj.ownerDocument) === "object";
	        }
	    }

	    /**
	     * @ngdoc method
	     * @name xhr
	     * @description call the API
	     * @param {Object} options
	     * @comment
	     * ```
	        var options = {
	            method: 'GET', // POST, DELETE, PUT
	            path: '/0.6/changesets', //without the /api
	            data: content //if you need a payload
	        };
	        osmAPI.xhr(options);
	        ```
	     * @methodOf osm.api.osmAPI
	     * @return {Object} oauth
	    */
	    this.xhr = function (options) {
	        var deferred = $q.defer();
	        var promise = void 0;
	        var hasOauth = this._oauth;
	        if (hasOauth) {
	            options.path = '/api' + options.path;
	            if (options.data) {
	                options.body = options.data;
	                options.data = undefined;
	            }
	            promise = this._oauth.xhr(options);
	        } else {
	            options.url = this.url + options.path;
	            options.headers = {
	                Authorization: this.getAuthorization()
	            };
	            promise = $http(options);
	        }
	        promise.then(function (data) {
	            var d;
	            var t = function t(d) {
	                if (!d) {
	                    return d;
	                }
	                if (d.substr) {
	                    if (d.substr(0, 5) === '<?xml') {
	                        return osmUtilsService.xml2js(d);
	                    }
	                } else if (isElement(d)) {
	                    return osmUtilsService.x2js.dom2js(d);
	                }
	                return d;
	            };
	            if (hasOauth) {
	                d = data;
	            } else {
	                d = data.data;
	            }
	            deferred.resolve(t(d));
	        }, function (error) {
	            deferred.reject(error);
	        });
	        return deferred.promise;
	    };

	    /**
	     * @ngdoc method
	     * @name getAuthenticated
	     * @description send a get request to OSM with
	     * base64 crendentials in header
	     * @methodOf osm.api.osmAPI
	     * @returns {Promise} $http response
	    */
	    this.getAuthenticated = function (method, config) {
	        var _config = angular.copy(config);
	        if (!_config) {
	            _config = {};
	        }
	        _config.method = 'GET';
	        _config.path = method;
	        return this.xhr(_config);
	    };
	    /**
	     * @ngdoc method
	     * @name get
	     * @description send a get request
	     * @methodOf osm.api.osmAPI
	     * @param {string} method the api method
	     * @param {Object} config the $http.get config
	     * @returns {Promise} $http response with XML as string
	    */
	    this.get = function (method, config) {
	        var deferred = $q.defer();
	        var self = this;
	        var url = this.url + method;
	        $http.get(url, config).then(function (data) {
	            deferred.resolve(osmUtilsService.xml2js(data.data));
	        }, function (error) {
	            deferred.reject(error);
	        });
	        return deferred.promise;
	    };
	    /**
	     * @ngdoc method
	     * @name put
	     * @description send a put request
	     * @methodOf osm.api.osmAPI
	     * @param {string} method the api method
	     * @param {Object} content payload
	     * @param {Object} config the $http.put config
	     * @returns {Promise} $http response
	    */
	    this.put = function (method, content, config) {
	        if (!config) {
	            config = {};
	        }
	        var _config = angular.copy(config);
	        _config.method = 'PUT';
	        _config.path = method;
	        _config.data = osmUtilsService.js2xml(content);
	        return this.xhr(_config);
	    };
	    /**
	     * @ngdoc method
	     * @name delete
	     * @description send a delete request
	     * @methodOf osm.api.osmAPI
	     * @param {string} method the api method
	     * @param {Object} config the $http.delete config
	     * @returns {Promise} $http response
	    */
	    this.delete = function (method, config) {
	        if (!config) {
	            config = {};
	        }
	        var _config = angular.copy(config);
	        _config.method = 'DELETE';
	        _config.path = method;
	        return this.xhr(_config);
	    };

	    // ------------------ CHANGESET -----------------

	    /**
	     * @ngdoc method
	     * @name createChangeset
	     * @methodOf osm.api.osmAPI
	     * @param {string} comment the comment assiociated to the changeset
	     * @returns {Promise} $http response
	    */
	    this.createChangeset = function (comment) {
	        var deferred = $q.defer();
	        var changeset = { osm: {
	                changeset: {
	                    tag: [{ _k: 'created_by', _v: 'Angular-OSM' }, { _k: 'comment', _v: comment }]
	                }
	            } };
	        this.put('/0.6/changeset/create', changeset).then(function (data) {
	            osmSettingsService.setChangeset(data);
	            deferred.resolve(data);
	        });
	        return deferred.promise;
	    };
	    /**
	     * @ngdoc method
	     * @name getLastOpenedChangesetId
	     * @methodOf osm.api.osmAPI
	     * @returns {Promise} $http response with the last changeset id
	     * or undefined if no changeset was opened
	    */
	    this.getLastOpenedChangesetId = function () {
	        var deferred = $q.defer();
	        var config = {
	            params: { user: osmSettingsService.getUserID(), open: true }
	        };
	        this.get('/0.6/changesets', config).then(function (data) {
	            var changesets = data.osm.changeset;
	            if (changesets.length > 0) {
	                osmSettingsService.setChangeset(changesets[0].id);
	                deferred.resolve(changesets[0].id);
	            } else if (changesets._id) {
	                osmSettingsService.setChangeset(changesets._id);
	                deferred.resolve(changesets._id);
	            } else {
	                osmSettingsService.setChangeset();
	                deferred.resolve();
	            }
	        });
	        return deferred.promise;
	    };
	    /**
	     * @ngdoc method
	     * @name closeChangeset
	     * @methodOf osm.api.osmAPI
	     * @returns {Promise} $http.put response of
	     * /0.6/changeset/CHANGESET_ID/close
	    */
	    this.closeChangeset = function () {
	        var changeset = osmSettingsService.getChangeset();
	        return this.put('/0.6/changeset/' + changeset + '/close').then(function (data) {
	            osmSettingsService.setChangeset();
	            return data;
	        });
	    };

	    // ------------------ USER API -----------------

	    /**
	     * @ngdoc method
	     * @name getUserById
	     * @methodOf osm.api.osmAPI
	     * @param {string} id of the user
	     * @returns {Promise} $http.get response
	     * /0.6/user/#id
	    */
	    this.getUserById = function (id) {
	        return this.getAuthenticated('/0.6/user/' + id);
	    };

	    /**
	     * @ngdoc method
	     * @name getUserDetails
	     * @methodOf osm.api.osmAPI
	     * @returns {Promise} $http.get response
	     * /0.6/user/details
	    */
	    this.getUserDetails = function () {
	        return this.getAuthenticated('/0.6/user/details');
	    };
	    /**
	     * @ngdoc method
	     * @name getUserPreferences
	     * @methodOf osm.api.osmAPI
	     * @returns {Promise} $http.get response
	     * /0.6/user/preferences
	    */
	    this.getUserPreferences = function () {
	        return this.getAuthenticated('/0.6/user/preferences');
	    };

	    /**
	     * @ngdoc method
	     * @name putUserPreferences
	     * @methodOf osm.api.osmAPI
	     * @param {string} key the preference key
	     * @param {string} value the preference value
	     * @returns {Promise} $http.get response
	     * /0.6/user/preferences
	    */
	    this.putUserPreferences = function (key, value) {
	        return this.put('/0.6/user/preferences/' + key, value);
	    };

	    //------------------ MAP DATA -------------------------

	    /**
	     * @ngdoc method
	     * @name getMap
	     * @methodOf osm.api.osmAPI
	     * @param {string} bbox left,bottom,right,top
	     * where:
	        left is the longitude of the left (westernmost) side of the bounding box.
	        bottom is the latitude of the bottom (southernmost) side of the bounding box.
	        right is the longitude of the right (easternmost) side of the bounding box.
	        top is the latitude of the top (northernmost) side of the bounding box.
	     * @returns {Promise} $http.get response
	     * /0.6/map?bbox=bbox
	    */
	    this.getMap = function (bbox) {
	        return this.get('/0.6/map?bbox=' + bbox);
	    };

	    /**
	     * @ngdoc method
	     * @name getMapGeoJSON
	     * @methodOf osm.api.osmAPI
	     * @param {string} bbox the bounding box
	     * @returns {Promise} $http.get response
	    */
	    this.getMapGeoJSON = function (bbox) {
	        var self = this;
	        var deferred = $q.defer();
	        self.getMap(bbox).then(function (nodes) {
	            var geojsonNodes = osmUtilsService.js2geojson(nodes);
	            deferred.resolve(geojsonNodes);
	        }, function (error) {
	            deferred.reject(error);
	        });
	        return deferred.promise;
	    };

	    /**
	     * @ngdoc method
	     * @name getNotes
	     * @methodOf osm.api.osmAPI
	     * @param {string} bbox left,bottom,right,top
	     * where:
	        left is the longitude of the left (westernmost) side of the bounding box.
	        bottom is the latitude of the bottom (southernmost) side of the bounding box.
	        right is the longitude of the right (easternmost) side of the bounding box.
	        top is the latitude of the top (northernmost) side of the bounding box.
	     * @returns {Promise} $http.get response
	    */
	    this.getNotes = function (bbox) {
	        var url = '/0.6/notes?bbox=' + bbox;
	        return this.get(url);
	    };

	    //------------------ ELEMENTS: Node ----------------

	    /**
	     * @ngdoc method
	     * @name createNode
	     * @methodOf osm.api.osmAPI
	     * @param {Object/string} node
	         var node = {osm: {node: {
	            _changeset: '12', _lat: '...', _lon: '...',
	            tags: [
	                {_k: '...', _v: '...'}
	            ]
	        }}};
	     * @returns {Promise} $http.put response
	     * PUT /0.6/node/create
	    */
	    this.createNode = function (node) {
	        return this.put('/0.6/node/create', node);
	    };

	    /**
	     * @ngdoc method
	     * @name getNode
	     * @methodOf osm.api.osmAPI
	     * @param {string} id
	     * @returns {Promise} $http.get response
	     * GET /0.6/node/#id
	    */
	    this.getNode = function (id) {
	        return this.get('/0.6/node/' + id);
	    };

	    /**
	     * @ngdoc method
	     * @name getNodeRelations
	     * @methodOf osm.api.osmAPI
	     * @param {string} id
	     * @returns {Promise} $http.get response
	     * GET /0.6/node/#id/relations
	    */
	    this.getNodeRelations = function (id) {
	        return this.get('/0.6/node/' + id + '/relations');
	    };

	    /**
	     * @ngdoc method
	     * @name getNodeWays
	     * @methodOf osm.api.osmAPI
	     * @param {string} id
	     * @returns {Promise} $http.get response
	     * GET /0.6/node/#id/ways
	    */
	    this.getNodeWays = function (id) {
	        return this.get('/0.6/node/' + id + '/ways');
	    };

	    /**
	     * @ngdoc method
	     * @name getNodeFull
	     * @methodOf osm.api.osmAPI
	     * @param {string} id
	     * @returns {Promise} $http.get response
	     * GET /0.6/node/#id/full
	    */
	    this.getNodeFull = function (id) {
	        return this.get('/0.6/node/' + id + '/full');
	    };

	    /**
	     * @ngdoc method
	     * @name getNodes
	     * @methodOf osm.api.osmAPI
	     * @param {array} ids
	     * @returns {Promise} $http.get response
	     * GET /0.6/node/#id
	    */
	    this.getNodes = function (ids) {
	        return this.get('/0.6/nodes?nodes=' + ids.join(','));
	    };

	    /**
	     * @ngdoc method
	     * @name deleteNode
	     * @methodOf osm.api.osmAPI
	     * @param {string} id
	     * @returns {Promise} $http.delete response
	     * DELETE /0.6/node/#id
	    */
	    this.deleteNode = function (id) {
	        return this.delete('/0.6/node/' + id);
	    };

	    //------------------ ELEMENTS: WAY ----------------

	    /**
	     * @ngdoc method
	     * @name createWay
	     * @methodOf osm.api.osmAPI
	     * @param {Object/string} way
	        var way = {osm: {way: {
	            _changeset: '12', _lat: '...', _lon: '...',
	            tags: [
	                {_k: '...', _v: '...'}
	            ],
	            nd: [
	                {_ref: '123'},
	                {_ref: '456'},
	            ]
	        }}};
	     * @returns {Promise} $http.put response
	     * PUT /0.6/way/create
	    */
	    this.createWay = function (way) {
	        return this.put('/0.6/way/create', way);
	    };

	    /**
	     * @ngdoc method
	     * @name getWay
	     * @methodOf osm.api.osmAPI
	     * @param {string} id
	     * @returns {Promise} $http.get response
	     * GET /0.6/way/#id
	    */
	    this.getWay = function (id) {
	        return this.get('/0.6/way/' + id);
	    };

	    /**
	     * @ngdoc method
	     * @name getWayRelations
	     * @methodOf osm.api.osmAPI
	     * @param {string} id
	     * @returns {Promise} $http.get response
	     * GET /0.6/way/#id/relations
	    */
	    this.getWayRelations = function (id) {
	        return this.get('/0.6/way/' + id + '/relations');
	    };

	    /**
	     * @ngdoc method
	     * @name getWayFull
	     * @methodOf osm.api.osmAPI
	     * @param {string} id
	     * @returns {Promise} $http.get response
	     * GET /0.6/way/#id/full
	    */
	    this.getWayFull = function (id) {
	        return this.get('/0.6/way/' + id + '/full');
	    };

	    /**
	     * @ngdoc method
	     * @name getWays
	     * @methodOf osm.api.osmAPI
	     * @param {array} ids
	     * @returns {Promise} $http.get response
	     * GET /0.6/ways?ways=ids
	    */
	    this.getWays = function (ids) {
	        return this.get('/0.6/ways?ways=' + ids.join(','));
	    };

	    /**
	     * @ngdoc method
	     * @name deleteWay
	     * @methodOf osm.api.osmAPI
	     * @param {string} id
	     * @returns {Promise} $http.delete response
	     * DELETE /0.6/way/#id
	    */
	    this.deleteWay = function (id) {
	        return this.delete('/0.6/way/' + id);
	    };

	    //------------------ ELEMENTS: RELATION ----------------

	    /**
	     * @ngdoc method
	     * @name createRelation
	     * @methodOf osm.api.osmAPI
	     * @param {Object/string} relation
	        var relation = {osm: {relation: {
	            _changeset: '12', _lat: '...', _lon: '...',
	            tags: [
	                {_k: '...', _v: '...'}
	            ],
	            member: [
	                {_type: 'node', _role: 'stop', 'ref': '123'},
	                {_type: 'way', 'ref': '234'}
	            ]
	        }}};
	     * @returns {Promise} $http.put response
	     * PUT /0.6/relation/create
	    */
	    this.createRelation = function (relation) {
	        return this.put('/0.6/relation/create', relation);
	    };

	    /**
	     * @ngdoc method
	     * @name getRelation
	     * @methodOf osm.api.osmAPI
	     * @param {string} id
	     * @returns {Promise} $http.get response
	     * GET /0.6/relation/#id
	    */
	    this.getRelation = function (id) {
	        return this.get('/0.6/relation/' + id);
	    };
	    /**
	     * @ngdoc method
	     * @name getRelationRelations
	     * @methodOf osm.api.osmAPI
	     * @param {string} id
	     * @returns {Promise} $http.get response
	     * GET /0.6/relation/#id/relations
	    */
	    this.getRelationRelations = function (id) {
	        return this.get('/0.6/relation/' + id + '/relations');
	    };

	    /**
	     * @ngdoc method
	     * @name getRelationFull
	     * @methodOf osm.api.osmAPI
	     * @param {string} id
	     * @returns {Promise} $http.get response
	     * GET /0.6/relation/#id/full
	    */
	    this.getRelationFull = function (id) {
	        return this.get('/0.6/relation/' + id + '/full');
	    };

	    /**
	     * @ngdoc method
	     * @name getRelations
	     * @methodOf osm.api.osmAPI
	     * @param {array} ids
	     * @returns {Promise} $http.get response
	     * GET /0.6/relations?relations=ids
	    */
	    this.getRelations = function (ids) {
	        return this.get('/0.6/relations?relations=' + ids.join(','));
	    };

	    /**
	     * @ngdoc method
	     * @name deleteRelation
	     * @methodOf osm.api.osmAPI
	     * @param {string} id
	     * @returns {Promise} $http.delete response
	     * DELETE /0.6/relation/#id
	    */
	    this.deleteRelation = function (id) {
	        return this.delete('/0.6/relation/' + id);
	    };
	}

	exports.default = osmAPI;

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _settings = __webpack_require__(5);

	var _settings2 = _interopRequireDefault(_settings);

	var _ngstorage = __webpack_require__(6);

	var _ngstorage2 = _interopRequireDefault(_ngstorage);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var ngStorageModuleName = _ngstorage2.default ? _ngstorage2.default.name : 'ngStorage';

	var osmSettingsModule = angular.module('osm.settings', [ngStorageModuleName]).service('osmSettingsService', _settings2.default);

	exports.default = osmSettingsModule;

/***/ },
/* 5 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	/**
	 * @ngdoc service
	 * @name osmSettingsService
	 * @description provide service to access to settings
	 * @param  {any} $localStorage
	 */
	osmSettingsService.$inject = ['$localStorage'];
	function osmSettingsService($localStorage) {

	    this.localStorage = $localStorage.$default({
	        userName: '',
	        userID: '',
	        credentials: '',
	        changeset: ''
	    });
	    this.getUserName = function () {
	        return this.localStorage.userName;
	    };
	    this.setUserName = function (username) {
	        this.localStorage.userName = username;
	    };
	    this.getUserID = function () {
	        return this.localStorage.userID;
	    };
	    this.setUserID = function (userid) {
	        this.localStorage.userID = userid;
	    };
	    this.getCredentials = function () {
	        return this.localStorage.credentials;
	    };
	    this.setCredentials = function (credentials) {
	        this.localStorage.credentials = credentials;
	    };
	    this.getChangeset = function () {
	        return this.localStorage.changeset;
	    };
	    this.setChangeset = function (changeset) {
	        this.localStorage.changeset = changeset;
	    };
	    this.getOsmAuth = function () {
	        return this.localStorage.osmAuth;
	    };
	    this.setOsmAuth = function (options) {
	        this.localStorage.osmAuth = options;
	    };
	}

	exports.default = osmSettingsService;

/***/ },
/* 6 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_6__;

/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _utils = __webpack_require__(8);

	var _utils2 = _interopRequireDefault(_utils);

	var _settings = __webpack_require__(4);

	var _settings2 = _interopRequireDefault(_settings);

	var _x2js = __webpack_require__(9);

	var _x2js2 = _interopRequireDefault(_x2js);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var osmUtilsModule = angular.module('osm.utils', [_settings2.default.name, _x2js2.default.name]).service('osmUtilsService', _utils2.default);

	exports.default = osmUtilsModule;

/***/ },
/* 8 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	/**
	 * @ngdoc service
	 * @name osm.utils.osmUtilsService
	 */
	function osmUtilsService($http, osmSettingsService, osmx2js) {

	    /**
	     * @ngdoc method
	     * @name relationToGeoJSON
	     * @methodOf osm.utils.osmUtilsService
	     * @param {Number} relationId id of the relation
	     * @param {Object} relation json object
	     * @return {Object} geojson
	     */
	    this.relationToGeoJSON = function (relationID, relation) {
	        var self = this;
	        var features = [];
	        var relations = [];
	        var result = {
	            type: 'FeatureCollection',
	            properties: {
	                id: relationID
	            },
	            options: {},
	            members: [],
	            features: features,
	            relations: relations
	        };
	        var relation = relationXML.getElementById(relationID);
	        //bug: relation is null because firefox return an error
	        result.properties.visible = relation.getAttribute('visible');
	        result.properties.version = relation.getAttribute('version');
	        result.properties.changeset = relation.getAttribute('changeset');
	        result.properties.timestamp = relation.getAttribute('timestamp');
	        result.properties.user = relation.getAttribute('user');
	        result.properties.uid = relation.getAttribute('uid');
	        var m, i;
	        var child, node, properties, coordinates, feature, member, memberElement;
	        for (i = 0; i < relation.children.length; i++) {
	            m = relation.children[i];
	            if (m.tagName === 'member') {
	                //<member type="way" ref="148934766" role=""/>
	                member = {
	                    type: m.getAttribute('type'),
	                    ref: m.getAttribute('ref'),
	                    role: m.getAttribute('role')
	                };
	                result.members.push(member);
	                //get relationXML for this member
	                memberElement = relationXML.getElementById(m.getAttribute('ref'));
	                /*
	                <way id="148934766" visible="true" version="5" changeset="13626362" timestamp="2012-10-25T11:48:27Z" user="Metacity" uid="160224">
	                    <nd ref="1619955810"/>
	                    ...
	                    <tag k="access" v="yes"/>
	                    ...
	                </way>
	                    */
	                //get tags -> geojson properties
	                properties = self.getTagsFromChildren(memberElement);
	                member.name = properties.name;
	                if (memberElement.tagName === 'way') {
	                    coordinates = [];
	                    feature = {
	                        type: 'Feature',
	                        properties: properties,
	                        id: m.getAttribute('ref'),
	                        geometry: {
	                            type: 'LineString',
	                            coordinates: coordinates
	                        }
	                    };
	                    for (var j = 0; j < memberElement.children.length; j++) {
	                        child = memberElement.children[j];
	                        if (child.tagName === 'nd') {
	                            node = relationXML.getElementById(child.getAttribute('ref'));
	                            coordinates.push([parseFloat(node.getAttribute('lon')), parseFloat(node.getAttribute('lat'))]);
	                        }
	                    }
	                    features.push(feature);
	                } else if (memberElement.tagName === 'node') {
	                    feature = {
	                        type: 'Feature',
	                        properties: properties,
	                        id: m.getAttribute('ref'),
	                        geometry: {
	                            type: 'Point',
	                            coordinates: [parseFloat(memberElement.getAttribute('lon')), parseFloat(memberElement.getAttribute('lat'))]
	                        }
	                    };
	                    features.push(feature);
	                } else if (memberElement.tagName === 'relation') {
	                    member.tags = properties;
	                }
	            }
	        }
	        result.tags = self.getTagsFromChildren(relation);
	        return result;
	    };

	    /**
	     * @ngdoc method
	     * @name encodeXML
	     * @methodOf osm.utils.osmUtilsService
	     * @param {string} str the string to encode
	     * @return {string} the encoded string
	     */
	    this.encodeXML = function (str) {
	        return str.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;').replace(/'/g, '&apos;');
	    };
	    /**
	     * @ngdoc method
	     * @name relationGeoJSONToXml
	     * @methodOf osm.utils.osmUtilsService
	     * @param {Object} relationGeoJSON geojson
	     * @return {string} relation as xml
	     */
	    this.relationGeoJSONToXml = function (relationGeoJSON) {
	        var i;
	        var pp = relationGeoJSON.properties;
	        var members = relationGeoJSON.members;
	        var settings = osmSettingsService;
	        var output = '<?xml version="1.0" encoding="UTF-8"?>\n';
	        output += '<osm version="0.6" generator="angular-osm 0.2" copyright="OpenStreetMap and contributors" attribution="http://www.openstreetmap.org/copyright" license="http://opendatacommons.org/licenses/odbl/1-0/">\n';
	        output += '  <relation id="' + pp.id + '" visible="' + pp.visible + '" ';
	        output += 'version="' + pp.version + '" ';
	        output += 'changeset="' + settings.getChangeset() + '" timestamp="' + new Date().toISOString() + '" ';
	        output += 'user="' + settings.getUserName() + '" uid="' + pp.uid + '">\n';

	        for (i = 0; i < members.length; i++) {
	            output += '    <member type="' + members[i].type + '" ';
	            output += 'ref="' + members[i].ref;
	            //role depends on the type of member
	            if (members[i].type === 'relation') {
	                output += '" role="' + members[i].role + '"/>\n';
	            } else {
	                output += '" role="' + members[i].role + '"/>\n';
	            }
	        }

	        var tags = relationGeoJSON.tags;
	        for (var k in tags) {
	            output += '    <tag k="' + k + '" v="' + this.encodeXML(tags[k]) + '"/>\n';
	        }
	        output += '  </relation>\n';
	        output += '</osm>';
	        return output;
	    };
	    /**
	     * @ngdoc method
	     * @name sortRelationMembers
	     * @methodOf osm.utils.osmUtilsService
	     * @param {Object} relationGeoJSON geojson
	     * @return {Object} relation as geojson sorted
	     */
	    this.sortRelationMembers = function (relationGeoJSON) {
	        //sort members
	        var members = relationGeoJSON.members;
	        var features = relationGeoJSON.features;
	        var sorted = [];
	        var f, i, m, j, k;
	        var first, last;
	        var insertBefore = function insertBefore(item) {
	            sorted.splice(0, 0, item);
	        };
	        var insertAfter = function insertAfter(item) {
	            sorted.push(item);
	        };
	        var getCoordinates = function getCoordinates(i) {
	            return features[i].geometry.coordinates;
	        };
	        var c, cfirst, clast, alreadySorted;
	        var foundFirst,
	            foundLast = false;
	        for (i = 0; i < members.length; i++) {
	            m = members[i];
	            if (m.type !== 'way') {
	                sorted.push(m);
	                continue;
	            }
	            //check if the member is already in
	            alreadySorted = false;
	            for (k = 0; k < sorted.length; k++) {
	                if (sorted[k].ref === m.ref) {
	                    alreadySorted = true;
	                }
	            }
	            if (alreadySorted) {
	                continue;
	            }
	            if (sorted.length === 0) {
	                sorted.push(m);
	                c = getCoordinates(i);
	                cfirst = c[0];
	                clast = c[c.length - 1];
	            }
	            //                    console.log('cfirst ' +cfirst);
	            //                    console.log('clast '+ clast);
	            foundFirst = foundLast = false;
	            for (j = 0; j < features.length; j++) {
	                f = features[j];
	                if (f.geometry.type !== 'LineString') {
	                    continue;
	                }
	                alreadySorted = false;
	                for (k = 0; k < sorted.length; k++) {
	                    if (sorted[k].ref === f.id) {
	                        alreadySorted = true;
	                    }
	                }
	                if (alreadySorted) {
	                    continue;
	                }

	                c = getCoordinates(j);
	                first = c[0];
	                last = c[c.length - 1];
	                if (cfirst[0] === last[0] && cfirst[1] === last[1]) {
	                    insertBefore(members[j]);
	                    cfirst = first;
	                    foundFirst = true;
	                    continue;
	                }
	                if (clast[0] === first[0] && clast[1] === first[1]) {
	                    insertAfter(members[j]);
	                    clast = last;
	                    foundLast = true;
	                    continue;
	                }
	                //weird; order of linestring coordinates is not stable
	                if (cfirst[0] === first[0] && cfirst[1] === first[1]) {
	                    insertBefore(members[j]);
	                    cfirst = last;
	                    foundFirst = true;
	                    continue;
	                }
	                if (clast[0] === last[0] && clast[1] === last[1]) {
	                    insertAfter(members[j]);
	                    clast = first;
	                    foundLast = true;
	                    continue;
	                }
	            }
	            if (!foundFirst && !foundLast) {
	                //cas du rond point ... ?
	                console.log('not found connected ways for ' + m.ref);
	                console.log(cfirst);
	                console.log(clast);
	            }
	        }
	        if (members.length === sorted.length) {
	            relationGeoJSON.members = sorted;
	            //Fix orders of features
	            //var features = relationGeoJSON.features;
	            var cache = { loaded: false };
	            var getFeatureById = function getFeatureById(id) {
	                if (!cache.loaded) {
	                    for (var i = 0; i < features.length; i++) {
	                        cache[features[i].id] = features[i];
	                    }
	                }
	                return cache[id];
	            };
	            relationGeoJSON.features = [];
	            for (var l = 0; l < sorted.length; l++) {
	                relationGeoJSON.features.push(getFeatureById(sorted[l].ref));
	            }
	            //feature order fixed
	        } else {
	                console.error('can t sort this relation');
	            }
	        return relationGeoJSON;
	    };
	    this.x2js = osmx2js;
	    this.xml2js = function (xml_str) {
	        return osmx2js.xml2js(xml_str);
	    };
	    this.js2xml = function (json) {
	        return osmx2js.js2xml(json);
	    };
	    /**
	     * @ngdoc method
	     * @name yqlJSON
	     * @methodOf osm.utils.osmUtilsService
	     * @param {string} featuresURL url of the geojson you want to get
	     * @return {Promise} $http response
	     */
	    this.yqlJSON = function (featuresURL) {
	        var deferred = $q.defer();
	        var url, config;
	        config = {
	            params: {
	                q: 'select * from json where url=\'' + featuresURL + '\';',
	                format: 'json'
	            }
	        };
	        url = 'http://query.yahooapis.com/v1/public/yql';
	        $http.get(url, config).then(function (data) {
	            if (data.data.query.results === null) {
	                deferred.resolve([]);
	            } else {
	                deferred.resolve(data.data.query.results.json);
	            }
	        }, function (error) {
	            deferred.reject(error);
	        });
	        return deferred.promise;
	    };
	    /**
	     * @ngdoc method
	     * @name getElementTypeFromFeature
	     * @methodOf osm.utils.osmUtilsService
	     * @param {string} feature geojson feature
	     * @return {string} type 'node' or 'way'
	     */
	    this.getElementTypeFromFeature = function (feature) {
	        var gtype = feature.geometry.type;
	        if (gtype === 'LineString') {
	            return 'way';
	        } else if (gtype === 'Point') {
	            return 'node';
	        } else {
	            console.error('not supported type ' + gtype);
	        }
	    };
	}
	exports.default = osmUtilsService;

/***/ },
/* 9 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	//https://github.com/abdmob/x2js as angular service
	var osmx2jsModule = angular.module('osm.x2js', []).provider('osmx2js', function osmx2jsProvider() {
	    this.options = {};
	    this.$get = function osmx2jsFactory() {
	        return new X2JS(this.options); //X2JS must be global
	    };
	});

	exports.default = osmx2jsModule;

/***/ },
/* 10 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_10__;

/***/ },
/* 11 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _oauth = __webpack_require__(12);

	var _oauth2 = _interopRequireDefault(_oauth);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var osmOAuthModule = angular.module('osm.oauth', []).factory('osmAuthService', _oauth2.default).provider('osmAuthService', function osmAuthServiceProvider() {
	    this.options = {};

	    this.$get = function osmAuthServiceFactory($q) {
	        return new _oauth2.default($q, this.options);
	    };
	    this.$get.$inject = ['$q'];
	});

	exports.default = osmOAuthModule;

/***/ },
/* 12 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _osmAuth = __webpack_require__(13);

	var _osmAuth2 = _interopRequireDefault(_osmAuth);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	/**
	* @ngdoc service
	* @name osm.oauth.osmAuthService
	* @requires angular-osm.osmSettingsService
	* @description handle osm oauth
	*/
	function osmAuthService($q, options) {
	    if (options) {
	        if (options.oauth_secret && options.oauth_consumer_key) {
	            this.auth = osmAuth(options);
	        }
	    }
	    /**
	     * @ngdoc method
	     * @name logout
	     * @methodOf osm.auth.osmAuthService
	     */
	    this.logout = function () {
	        this.auth.logout();
	    };
	    /**
	     * @ngdoc method
	     * @name authenticated
	     * @methodOf osm.auth.osmAuthService
	     * @return {boolean} authenticated
	     */
	    this.authenticated = function () {
	        return this.auth.authenticated();
	    };
	    /**
	     * @ngdoc method
	     * @name authenticate
	     * @methodOf osm.auth.osmAuthService
	     * @return {Promise} true/false
	     */
	    this.authenticate = function () {
	        var deferred = $q.defer();
	        this.auth.authenticate(function () {
	            deferred.resolve(true);
	        });
	        return deferred.promise;
	    };
	    /**
	     * @ngdoc method
	     * @name xhr
	     * @methodOf osm.auth.osmAuthService
	     * @return {Promise} http response
	     */
	    this.xhr = function (options) {
	        var deferred = $q.defer();
	        this.auth.xhr(options, function (err, data) {
	            if (err) {
	                deferred.reject(err);
	            } else {
	                deferred.resolve(data);
	            }
	        });
	        return deferred.promise;
	    };
	    /**
	     * @ngdoc method
	     * @name options
	     * @methodOf osm.auth.osmAuthService
	     */
	    this.options = function (options) {
	        if (this.auth) {
	            this.auth.options(options);
	        } else {
	            this.auth = osmAuth(options);
	        }
	    };
	}

	exports.default = osmAuthService;

/***/ },
/* 13 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_13__;

/***/ },
/* 14 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _overpass = __webpack_require__(15);

	var _overpass2 = _interopRequireDefault(_overpass);

	var _settings = __webpack_require__(4);

	var _settings2 = _interopRequireDefault(_settings);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var osmOverpassModule = angular.module('osm.overpass', [_settings2.default.name]).factory('osmOverpassAPI', _overpass2.default).provider('osmOverpassAPI', function osmOverpassAPIProvider() {
	    this.options = {
	        url: 'http://overpass-api.de/api/interpreter'
	    };
	    this.$get = function osmOverpassAPIFactory($http, $q, osmSettingsService) {
	        return new _overpass2.default($http, $q, osmSettingsService, this.options);
	    };
	    this.$get.$inject = ['$http', '$q', 'osmSettingsService'];
	});

	exports.default = osmOverpassModule;

/***/ },
/* 15 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});


	/**
	 * @ngdoc service
	 * @name overpassAPI
	 * @param  {any} $http
	 * @param  {any} $q
	 * @param  {any} osmSettingsService
	 */
	function osmOverpassAPI($http, $q, osmSettingsService, options) {
	    this.url = options.url;
	    /**
	     * @ngdoc method
	     * @name overpass
	     * @param {Object/String} query
	     * http://wiki.openstreetmap.org/wiki/FR:Overpass_API
	     * @methodOf osm.overpass.osmOverpassAPI
	     * @return {Promise} $http.get
	    */
	    this.overpass = function (query) {
	        var self = this;
	        var url = self.url;
	        var deferred = $q.defer();
	        var headers = { 'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8' };
	        $http.post(url, 'data=' + encodeURIComponent(query), { headers: headers }).then(function (data) {
	            deferred.resolve(data.data);
	        }, function (data) {
	            deferred.reject(data);
	        });
	        return deferred.promise;
	    };
	    /**
	     * @ngdoc method
	     * @name overpass
	     * @description
	     * http://wiki.openstreetmap.org/wiki/FR:Overpass_API/Overpass_QL#By_area_.28area.29
	        By convention the area id can be calculated from an existing OSM way by adding 2400000000 to its OSM id, or in case of a relation by adding 3600000000 respectively. Note that area creation is subject to some extraction rules, i.e. not all ways/relations have an area counterpart (notably those that are tagged with area=no, and most multipolygons and that don't have a defined name=* will not be part of areas).
	     * @param {String} type 'r'/'relation' or 'w'/'way'
	     * @param {String/Number} osmId the id of the element
	     * @methodOf osm.overpass.osmOverpassAPI
	     * @return {Number} the area id
	    */
	    this.getAreaId = function (type, osmId) {
	        var id;
	        if (typeof osmId === 'string') {
	            id = parseInt(osmId, 10);
	        } else {
	            id = osmId;
	        }
	        if (type === 'r' || type === 'relation') {
	            return 3600000000 + id;
	        } else if (type === 'w' || type === 'way') {
	            return 2400000000 + id;
	        }
	    };
	    this.overpassToGeoJSON = function (query, filter) {
	        var deferred = $q.defer();
	        var features = [];
	        var relations = [];
	        var result = {
	            type: 'FeatureCollection',
	            features: features,
	            relations: relations
	        };
	        if (filter === undefined) {
	            filter = function filter() {};
	        }
	        this.overpass(query).then(function (data) {
	            //TODO check if data is XML or JSON, here it's JSON
	            var node, feature, coordinates;
	            var cache = { loaded: false };
	            function getNodeById(id) {
	                if (!cache.loaded) {
	                    var tmp;
	                    for (var i = 0; i < data.elements.length; i++) {
	                        tmp = data.elements[i];
	                        cache[tmp.id] = tmp;
	                    }
	                }
	                return cache[id];
	            };
	            for (var i = 0; i < data.elements.length; i++) {
	                node = data.elements[i];
	                if (node.type === 'node') {
	                    feature = {
	                        type: 'Feature',
	                        properties: node.tags,
	                        id: node.id,
	                        geometry: {
	                            type: 'Point',
	                            coordinates: [node.lon, node.lat]
	                        }
	                    };
	                    if (!filter(feature)) {
	                        features.push(feature);
	                    }
	                } else if (node.type === 'way') {
	                    coordinates = [];
	                    feature = {
	                        type: 'Feature',
	                        properties: node.tags,
	                        id: node.id,
	                        geometry: {
	                            type: 'LineString',
	                            coordinates: coordinates
	                        }
	                    };
	                    for (var j = 0; j < node.nodes.length; j++) {
	                        coordinates.push([getNodeById(node.nodes[j]).lon, getNodeById(node.nodes[j]).lat]);
	                    }
	                    if (!filter(feature)) {
	                        features.push(feature);
	                    }
	                } else if (node.type === 'relation') {
	                    result.relations.push({
	                        ref: node.id,
	                        tags: node.tags,
	                        type: 'relation',
	                        members: node.members
	                    });
	                }
	            }
	            deferred.resolve(result);
	        }, function (error) {
	            deferred.reject(error);
	        });
	        return deferred.promise;
	    };
	}

	exports.default = osmOverpassAPI;

/***/ },
/* 16 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _taginfo = __webpack_require__(17);

	var _taginfo2 = _interopRequireDefault(_taginfo);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var osmTagInfoModule = angular.module('osm.taginfo', []).service('osmTagInfoAPI', _taginfo2.default);

	exports.default = osmTagInfoModule;

/***/ },
/* 17 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	osmTagInfoAPI.$inject = ['$http', '$q'];
	/**
	 * @ngdoc service
	 * @name osmTagInfoAPI
	 * @description integration of taginfo
	 * http://taginfo.openstreetmap.org/taginfo/apidoc
	 * @param  {any} $http
	 * @param  {any} $q
	 */
	function osmTagInfoAPI($http, $q) {
	    this.get = function (method, config) {
	        var deferred = $q.defer();
	        $http.get('https://taginfo.openstreetmap.org/api/4' + method, config).then(function (data) {
	            deferred.resolve(data.data);
	        }, function (error) {
	            deferred.reject(error);
	        });
	        return deferred.promise;
	    };
	    /**
	     * @ngdoc method
	     * @name getKeyCombinations
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        key — Tag key (required).
	        query — Only show results where the other_key matches this query (substring match, optional).
	     */
	    this.getKeyCombinations = function (params) {
	        return this.get('/key/combinations', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getKeyDistributionNodes
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        key — Tag key (required).
	     */
	    this.getKeyDistributionNodes = function (params) {
	        return this.get('/key/distribution/nodes', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getKeyDistributionWays
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	     * key — Tag key (required).
	     */
	    this.getKeyDistributionWays = function (params) {
	        return this.get('/key/distribution/ways', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getKeyStats
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	     * key — Tag key (required).
	     */
	    this.getKeyStats = function (params) {
	        return this.get('/key/stats', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getKeyValues
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        key — Tag key (required).
	        lang — Language for description (optional, default: 'en').
	        query — Only show results where the value matches this query (substring match, optional).
	     */
	    this.getKeyValues = function (params) {
	        return this.get('/key/values', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getKeyWikiPages
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        key — Tag key (required).
	     */
	    this.getKeyWikiPages = function (params) {
	        return this.get('/key/wiki_pages', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getKeysAll
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        query — Only show keys matching this query (substring match, optional).
	     */
	    this.getKeysAll = function (params) {
	        return this.get('/keys/all', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getKeysWikiPages
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        query — Only show keys matching this query (substring match, optional).
	     */
	    this.getKeysWikiPages = function (params) {
	        return this.get('/keys/wiki_pages', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getKeysWithoutWikiPage
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        english — Check for key wiki pages in any language (0, default) or in the English language (1).
	        min_count — How many tags with this key must there be at least to show up here? (default 10000).
	        query — Only show results where the key matches this query (substring match, optional).
	     */
	    this.getKeysWithoutWikiPage = function (params) {
	        return this.get('/keys/without_wiki_page', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getRelationRoles
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        query — Only show results where the role matches this query (substring match, optional).
	        rtype — Relation type (required).
	     */
	    this.getRelationRoles = function (params) {
	        return this.get('/relation/roles', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getRelationStats
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        rtype — Relation type (required).
	     */
	    this.getRelationStats = function (params) {
	        return this.get('/relation/stats', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getRelationWikiPages
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        rtype — Relation type (required).
	     */
	    this.getRelationWikiPages = function (params) {
	        return this.get('/relation/wiki_pages', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getRelationsAll
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        query — Only show results where the relation type matches this query (substring match, optional).
	     */
	    this.getRelationsAll = function (params) {
	        return this.get('/relations/all', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getSearchByKeyAndValue
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        query — Value to search for (substring search, required).
	     */
	    this.getSearchByKeyAndValue = function (params) {
	        return this.get('/search/by_key_and_value', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getSearchByKeyword
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        query — Value to search for (substring search, required).
	     */
	    this.getSearchByKeyword = function (params) {
	        return this.get('/search/by_keyword', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getSearchByRole
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        query — Role to search for (substring search, required).
	     */
	    this.getSearchByRole = function (params) {
	        return this.get('/search/by_role', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getSearchByValue
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        query — Value to search for (substring search, required).
	     */
	    this.getSearchByValue = function (params) {
	        return this.get('/search/by_value', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getSiteInfo
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	         param: No params
	     */
	    this.getSiteInfo = function (params) {
	        return this.get('/site/info', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getSiteSources
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	         param: No params
	     */
	    this.getSiteSources = function (params) {
	        return this.get('/site/sources', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getTagCombinations
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        key — Tag key (required).
	        query — Only show results where the other_key or other_value matches this query (substring match, optional).
	        value — Tag value (required).
	     */
	    this.getTagCombinations = function (params) {
	        return this.get('/tag/combinations', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getTagDistributionNodes
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        key — Tag key (required).
	        value — Tag value (required).
	     */
	    this.getTagDistributionNodes = function (params) {
	        return this.get('/tag/distribution/nodes', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getTagDistributionWays
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        key — Tag key (required).
	        value — Tag value (required).
	     */
	    this.getTagDistributionWays = function (params) {
	        return this.get('/tag/distribution/ways', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getTagStats
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        key — Tag key (required).
	        value — Tag value (required).
	     */
	    this.getTagStats = function (params) {
	        return this.get('/tag/stats', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getTagWikiPages
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        key — Tag key (required).
	        value — Tag value (required).
	     */
	    this.getTagWikiPages = function (params) {
	        return this.get('/tag/wiki_pages', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getTagsPopular
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	        query — Only show tags matching this query (substring match in key and value, optional).
	     */
	    this.getTagsPopular = function (params) {
	        return this.get('/tags/popular', { params: params });
	    };
	    /**
	     * @ngdoc method
	     * @name getWikiLanguages
	     * @methodOf osm.taginfo.osmTagInfoAPI
	     * @param {any} params
	         param: No params
	     */
	    this.getWikiLanguages = function (params) {
	        return this.get('/wiki/languages', { params: params });
	    };
	}
	exports.default = osmTagInfoAPI;

/***/ },
/* 18 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _nominatim = __webpack_require__(19);

	var _nominatim2 = _interopRequireDefault(_nominatim);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var osmNominatimModule = angular.module('osm.nominatim', []).factory('osmNominatim', _nominatim2.default).provider('osmNominatim', function osmNominatimProvider() {
	    this.options = {
	        url: 'https://nominatim.openstreetmap.org'
	    };
	    this.$get = function osmNominatimFactory($q) {
	        return new _nominatim2.default($q, this.options);
	    };
	    this.$get.$inject = ['$http'];
	});

	exports.default = osmNominatimModule;

/***/ },
/* 19 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	/**
	* @ngdoc service
	* @name osm.nominatim.osmNominatim
	* @description handle nominatim query
	*/
	function osmNominatim($http, options) {
	    this.url = options.url;

	    /**
	     * @ngdoc method
	     * @name search
	     * @param {Object/String} query
	     * http://wiki.openstreetmap.org/wiki/Nominatim
	     * @methodOf osm.nominatim.osmNominatim
	     * @return {Promise} $http.get
	    */
	    this.search = function search(query) {
	        //https://nominatim.openstreetmap.org/search
	        //?X-Requested-With=overpass-turbo&format=json&q=vern-sur-seiche
	        //params['accept-language'] = 'fr';
	        var params;
	        if (typeof query === 'string' || !query) {
	            params = {
	                format: 'json',
	                q: query
	            };
	        } else {
	            params = angular.copy(query);
	            params.format = 'json';
	        }
	        var config = {
	            params: params
	        };
	        var url = this.url + '/search';
	        return $http.get(url, config);
	    };

	    /**
	     * @ngdoc method
	     * @name reverse
	     * @param {Object/String} query
	     * http://wiki.openstreetmap.org/wiki/Nominatim
	     * @methodOf osm.nominatim.osmNominatim
	     * @return {Promise} $http.get
	    */
	    this.reverse = function reverse(query) {
	        //https://nominatim.openstreetmap.org/reverse
	        //?X-Requested-With=overpass-turbo&format=json&q=vern-sur-seiche
	        //params['accept-language'] = 'fr';
	        var params;
	        if (typeof query === 'string') {
	            params = {
	                format: 'json',
	                q: query
	            };
	        } else {
	            params = angular.copy(query);
	            params.format = 'json';
	        }
	        var config = {
	            params: params
	        };
	        var url = this.url + '/reverse';
	        return $http.get(url, config);
	    };

	    /**
	     * @ngdoc method
	     * @name lookup
	     * @description
	     *  http://nominatim.openstreetmap.org/lookup?osm_ids=R146656,W104393803,N240109189
	     * @param {Object/String} query
	     * http://wiki.openstreetmap.org/wiki/Nominatim
	     * @methodOf osm.nominatim.osmNominatim
	     * @return {Promise} $http.get
	    */
	    this.lookup = function lookup(query) {
	        var params;
	        if (typeof query === 'string') {
	            params = {
	                format: 'json',
	                q: query
	            };
	        } else {
	            params = angular.copy(query);
	            params.format = 'json';
	        }
	        var config = {
	            params: params
	        };
	        var url = this.url + '/lookup';
	        return $http.get(url, config);
	    };
	}

	exports.default = osmNominatim;

/***/ },
/* 20 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _togeojson = __webpack_require__(21);

	var _togeojson2 = _interopRequireDefault(_togeojson);

	var _togeojson3 = __webpack_require__(22);

	var _togeojson4 = _interopRequireDefault(_togeojson3);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var osmtogeojsonModule = angular.module('osm.togeojson', []).factory('osmtogeojson', _togeojson4.default).provider('osmtogeojson', _togeojson2.default);

	exports.default = osmtogeojsonModule;

/***/ },
/* 21 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _togeojson = __webpack_require__(22);

	var _togeojson2 = _interopRequireDefault(_togeojson);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function osmtogejsonProvider() {
	    this.options = {
	        areaTags: ['area', 'building', 'leisure', 'tourism', 'ruins', 'historic', 'landuse', 'military', 'natural', 'sport'],
	        uninterestingTags: ['source', 'source_ref', 'source:ref', 'history', 'attribution', 'created_by', 'tiger:county', 'tiger:tlid', 'tiger:upload_uuid'],
	        styles: {}
	    };
	    this.$get = function () {
	        return (0, _togeojson2.default)(this.options);
	    };
	}
	exports.default = osmtogejsonProvider;

/***/ },
/* 22 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

	/**
	 * @ngdoc service
	 * @name osmtogeojson
	 * @description osm to geojson without dependencies :)
	   
	   Import Note : geojson wait for lon/lat where every body else use lat/lon
	 */
	function factory(options) {
	    //copy/pasted/adapter from https://github.com/jfirebaugh/leaflet-osm/blob/master/leaflet-osm.js
	    var service = {
	        options: options,
	        getAsArray: getAsArray,
	        getFeatures: getFeatures,
	        getNodes: getNodes,
	        getWays: getWays,
	        getRelations: getRelations,
	        getTags: getTags,
	        buildFeatures: buildFeatures,
	        isWayArea: isWayArea,
	        interestingNode: interestingNode,
	        togeojson: togeojson
	    };
	    return service;

	    function getFeatures(data) {
	        var features = [];
	        if (!(data instanceof Array)) {
	            data = buildFeatures(data);
	        }

	        for (var i = 0; i < data.length; i++) {
	            var d = data[i];
	            var feature = {
	                type: 'Feature',
	                geometry: {},
	                properties: {
	                    id: d.id,
	                    tags: d.tags
	                }
	            };
	            if (d.type === "changeset") {
	                //build rectangle
	                // X = Long; Y = Lat, lets do it clockwise
	                feature.geometry.type = 'Polygon';
	                var bounds = d.latLngBounds;
	                feature.geometry.coordinates = [[parseFloat(bounds._min_lon), parseFloat(bounds._min_lat)], [parseFloat(bounds._min_lon), parseFloat(bounds._max_lat)], [parseFloat(bounds._max_lon), parseFloat(bounds._max_lat)], [parseFloat(bounds._max_lon), parseFloat(bounds._min_lat)]];
	            } else if (d.type === "node") {
	                //add a Point
	                feature.geometry.type = 'Point';
	                feature.geometry.coordinates = [d.latLng[1], d.latLng[0]];
	            } else {
	                var lngLats = new Array(d.nodes.length);

	                for (var j = 0; j < d.nodes.length; j++) {
	                    var latLng = d.nodes[j].latLng;
	                    lngLats[j] = [latLng[1], latLng[0]];
	                }

	                if (isWayArea(d)) {
	                    lngLats.pop(); // Remove last == first.
	                    feature.geometry.type = 'Polygon';
	                    feature.geometry.coordinates = lngLats;
	                } else {
	                    feature.geometry.type = 'LineString';
	                    feature.geometry.coordinates = lngLats;
	                }
	            }
	            features.push(feature);
	        }
	        return features;
	    }
	    function getAsArray(data) {
	        if (Array.isArray(data)) {
	            return data;
	        } else if ((typeof data === 'undefined' ? 'undefined' : _typeof(data)) === "object") {
	            return [data];
	        } else {
	            return [];
	        }
	    }
	    function getTags(data) {
	        var rawtags = getAsArray(data.tag);
	        var tags = {};
	        rawtags.forEach(function (t) {
	            tags[t._k] = t._v;
	        });
	        return tags;
	    }
	    function getChangesets(data) {
	        var result = [];

	        var nodes = getAsArray(data.osm.changeset);
	        for (var i = 0; i < nodes.length; i++) {
	            var node = nodes[i];
	            result.push({
	                id: node._id,
	                type: "changeset",

	                latLngBounds: node,
	                tags: getTags(node)
	            });
	        }

	        return result;
	    }

	    function getNodes(data) {
	        var nodesAsArray = getAsArray(data.osm.node);
	        var nodesById = {};
	        nodesAsArray.forEach(function (node) {
	            nodesById[node._id] = {
	                id: node._id,
	                type: 'node',
	                latLng: [parseFloat(node._lat), parseFloat(node._lon)],
	                tags: getTags(node)
	            };
	        });
	        return nodesById;
	    }
	    function getWays(data, nodes) {
	        var result = [];
	        var ways = getAsArray(data.osm.way);
	        var features = [];
	        ways.forEach(function (way) {
	            var nds = way.nd;
	            var way_object = {
	                id: way._id,
	                type: "way",
	                nodes: new Array(nds.length),
	                tags: getTags(way)
	            };
	            for (var j = 0; j < nds.length; j++) {
	                way_object.nodes[j] = nodes[nds[j]._ref];
	            }
	            result.push(way_object);
	        });
	        return result;
	    }
	    function getRelations(data, nodes, way) {
	        var result = [];

	        var rels = getAsArray(data.osm.relation);
	        for (var i = 0; i < rels.length; i++) {
	            var rel = rels[i];
	            var members = getAsArray(rel.member);
	            var rel_object = {
	                id: rel._id,
	                type: "relation",
	                members: new Array(members.length),
	                tags: getTags(rel)
	            };
	            for (var j = 0; j < members.length; j++) {
	                if (members[j]._type === "node") {
	                    rel_object.members[j] = nodes[members[j]._ref];
	                } else {
	                    // relation-way and relation-relation membership not implemented
	                    rel_object.members[j] = null;
	                }
	            }
	            result.push(rel_object);
	        }
	        return result;
	    }

	    function buildFeatures(data) {
	        var features = [];
	        var nodes = getNodes(data); //-> {id: data, ...}
	        var ways = getWays(data, nodes); //->[]
	        var relations = getRelations(data, nodes, ways); //->[]

	        for (var node_id in nodes) {
	            var node = nodes[node_id];
	            if (interestingNode(node, ways, relations)) {
	                features.push(node);
	            }
	        }

	        for (var i = 0; i < ways.length; i++) {
	            var way = ways[i];
	            features.push(way);
	        }

	        return features;
	    }

	    function isWayArea(way) {
	        if (way.nodes[0] != way.nodes[way.nodes.length - 1]) {
	            return false;
	        }

	        for (var key in way.tags) {
	            if (options.areaTags.indexOf(key)) {
	                return true;
	            }
	        }

	        return false;
	    }

	    function interestingNode(node, ways, relations) {
	        var used = false;

	        for (var i = 0; i < ways.length; i++) {
	            if (ways[i].nodes.indexOf(node) >= 0) {
	                used = true;
	                break;
	            }
	        }

	        if (!used) {
	            return true;
	        }

	        for (var _i = 0; _i < relations.length; _i++) {
	            if (relations[_i].members.indexOf(node) >= 0) {
	                return true;
	            }
	        }

	        return false;
	    }
	    function togeojson(data, options) {
	        var res = {
	            type: 'FeatureCollection',
	            features: []
	        };
	        if (data) {
	            res.features = getFeatures(data);
	        }
	        return res;
	    };
	}

	exports.default = factory;

/***/ }
/******/ ])
});
;